#ifndef __RTAVR_DEFS_H__
#define __RTAVR_DEFS_H__

#define IOR_HAVE_CPI0
#define IOR_HAVE_GPIOR0
#define IOR_HAVE_GPIOR1
#define IOR_HAVE_GPIOR2
#define IOR_HAVE_PORTA
#define IOR_HAVE_PORTB
#define IOR_HAVE_PORTC
#define IOR_HAVE_SREG_SP
#define IOR_HAVE_INT0
#define IOR_HAVE_INT1
#define IOR_HAVE_RAMWIN
#define IOR_HAVE_RAMWIN_HA
#define IOR_HAVE_NVM
#define IOR_HAVE_TIM0
#define IOR_HAVE_TIM0_OC0A
#define IOR_HAVE_TIM0_OC0B
#define IOR_HAVE_SPI
#define IOR_HAVE_USART
// #define IOR_HAVE_TWI 	// notyet
#define IOR_HAVE_CPI1
    #define IOR_HAVE_CPI
    #define IOR_HAVE_CPI
#define INT0_vect_num            1
#define INT0_vect	_VECTOR(1)
#define INT1_vect_num            2
#define INT1_vect	_VECTOR(2)
//#define INT2_vect_num            3
#define INT2_vect	_VECTOR(3)
//#define INT3_vect_num            4
#define INT3_vect	_VECTOR(4)
#define CPI0_vect_num            5
#define CPI0_vect	_VECTOR(5)
#define CPI1_vect_num            6
#define CPI1_vect	_VECTOR(6)
#define TIM0_COMPA_vect_num     11
#define TIM0_COMPA_vect	_VECTOR(11)
#define TIM0_COMPB_vect_num     12
#define TIM0_COMPB_vect	_VECTOR(12)
#define TIM0_OVF_vect_num       13
#define TIM0_OVF_vect	_VECTOR(13)
#define USART_TX_vect_num       14
#define USART_TX_vect	_VECTOR(14)
#define USART_UDRE_vect_num     15
#define USART_UDRE_vect	_VECTOR(15)
#define TWI_SLAVE_vect_num      16
#define TWI_SLAVE_vect	_VECTOR(16)
#define SPI_vect_num            17
#define SPI_vect	_VECTOR(17)
#define USART_RX_vect_num       18
#define USART_RX_vect	_VECTOR(18)
#define	 __PORTA_ADDR  0x00   // PINA 0x00 , DDRA, PORTA
#define	 __PORTB_ADDR  0x04   // PINB 0x04 , DDRB, PORTB
#define	 __PORTC_ADDR  0x1b   // PINC 0x1b , DDRC, PORTC
#define	 __RAMWIN_ADDR 0x1f   // RAMDR 0x1f , RAMAR 0x20
#define	 __TIM0_ADDR   0x15   // OCR0B 0x15 - TCCR0A 0x19
#define	 __SREG_ADDR   0x3f   // SREG 0x3f , SPH,SPL,CCP,RSRFR,MCUCR 0x3a
#define	 __MCUCR_ADDR  0x3a   // MCUCR 0x3a
#define	 __GIFR_ADDR   0x0b   // GIFR 0x0b , GIMSK 0x0c
#define	 __TIFR_ADDR   0x25   // TIFR 0x25 , TIMSK 0x26  
#define	 __NVM_ADDR    0x32   // NVMCSR 0x32 , NVMCMD 0x33  
#define	 __USART_ADDR  0x0e   // USART : (0x0e - 0x14 ADC space)
#define	 __SPI_ADDR    0x2e    // SPI : SPDR 0x2e, SPSR, SPCR
#define	 __TWI_ADDR    0x28    // TWI : TWSD 0x28, TWSAM,TWSA, TWSSRA
#define	 __CPI0_ADDR   0x36    // CPI0 : CPCSR0 0x36, CPDR0
#define	 __CPI1_ADDR   0x34    // CPI1 : CPCSR1 0x34, CPDR1
#define	 __GPIOR0_ADDR  0x03   // 
#define	 __GPIOR1_ADDR  0x07   // 
#define	 __GPIOR2_ADDR  0x08   // 
#define	 __INT0_BIT  18     // PC2
#define INT0_DDR	DDRC
#define INT0_PORT	PORTC
#define INT0_PIN	PINC
#define INT0_BIT	2

#define	 __INT1_BIT  10     // PB2
#define INT1_DDR	DDRB
#define INT1_PORT	PORTB
#define INT1_PIN	PINB
#define INT1_BIT	2

#define	 __OC0A_BIT  16     // PC0
#define OC0A_DDR	DDRC
#define OC0A_PORT	PORTC
#define OC0A_PIN	PINC
#define OC0A_BIT	0

#define	 __OC0B_BIT   5     // PA5
#define OC0B_DDR	DDRA
#define OC0B_PORT	PORTA
#define OC0B_PIN	PINA
#define OC0B_BIT	5

#define	 __SS_BIT    16     // PC0
#define SS_DDR	DDRC
#define SS_PORT	PORTC
#define SS_PIN	PINC
#define SS_BIT	0

#define	 __SCK_BIT   17     // PC1
#define SCK_DDR	DDRC
#define SCK_PORT	PORTC
#define SCK_PIN	PINC
#define SCK_BIT	1

#define	 __MOSI_BIT  20     // PC4
#define MOSI_DDR	DDRC
#define MOSI_PORT	PORTC
#define MOSI_PIN	PINC
#define MOSI_BIT	4

#define	 __MISO_BIT  18     // PC2
#define MISO_DDR	DDRC
#define MISO_PORT	PORTC
#define MISO_PIN	PINC
#define MISO_BIT	2

#define	 __RX_BIT    21     // PC5
#define RX_DDR	DDRC
#define RX_PORT	PORTC
#define RX_PIN	PINC
#define RX_BIT	5

#define	 __TX_BIT    22     // PC6
#define TX_DDR	DDRC
#define TX_PORT	PORTC
#define TX_PIN	PINC
#define TX_BIT	6

#define	 __XCK_BIT   23     // PC7
#define XCK_DDR	DDRC
#define XCK_PORT	PORTC
#define XCK_PIN	PINC
#define XCK_BIT	7

#define	 __SDA_BIT   20     // PC4
#define SDA_DDR	DDRC
#define SDA_PORT	PORTC
#define SDA_PIN	PINC
#define SDA_BIT	4

#define	 __SCL_BIT   17     // PC1
#define SCL_DDR	DDRC
#define SCL_PORT	PORTC
#define SCL_PIN	PINC
#define SCL_BIT	1


#endif __RTAVR_DEFS_H__
